diff --git a/build.gradle.kts b/build.gradle.kts
index 0a876d2c9..486d5f862 100644
--- a/build.gradle.kts
+++ b/build.gradle.kts
@@ -1,6 +1,5 @@
 import com.github.jengelman.gradle.plugins.shadow.tasks.ShadowJar
 import com.github.jengelman.gradle.plugins.shadow.transformers.Log4j2PluginsCacheFileTransformer
-import org.gradle.internal.os.OperatingSystem
 import java.text.SimpleDateFormat
 import java.util.*
 
@@ -11,8 +10,9 @@ plugins {
 }
 
 group = "net.minecraft"
-version = "7.2"
-val buildChannel = "STABLE"
+version = "7.3"
+val texturePackVersion = 3;
+val buildChannel = "DEVELOPMENT"
 
 run {
     val file = File("version.txt")
@@ -36,7 +36,15 @@ task("generateJava", Copy::class) {
     from("src/template/java")
     into("src/main/java")
     include("**/*.java")
-    expand(mapOf("version" to version, "buildTime" to SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(Date()), "buildChannel" to buildChannel))
+    expand(mapOf("version" to version, "buildTime" to SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(Date()), "buildChannel" to buildChannel, "packVersion" to texturePackVersion))
+}
+
+task("runRecipeGenerator", JavaExec::class) {
+    group = "bta"
+    mainClass.set("net.minecraft.datagen.RecipesGenerator")
+    classpath = sourceSets["main"].runtimeClasspath
+
+    args = listOf("--output", File(buildDir, "resources/common/recipes").toString())
 }
 
 tasks.withType(JavaCompile::class.java) {
@@ -52,7 +60,7 @@ tasks.withType(JavaCompile::class.java) {
 task("jarClient", ShadowJar::class) {
     group = "bta"
     configurations = listOf(clientInclude)
-    dependsOn(tasks["generateJava"])
+    dependsOn(tasks["generateJava"], tasks["runRecipeGenerator"])
 
     from(sourceSets["main"].output.classesDirs)
     from(sourceSets["main"].resources)
@@ -66,7 +74,7 @@ task("jarClient", ShadowJar::class) {
 task("jarServer", ShadowJar::class) {
     group = "bta"
     configurations = listOf(serverInclude)
-    dependsOn(tasks["generateJava"])
+    dependsOn(tasks["generateJava"], tasks["runRecipeGenerator"])
 
     from(sourceSets["main"].output.classesDirs)
     archiveFileName.set("bta-server.jar")
@@ -170,6 +178,7 @@ task("copyNatives", Copy::class) {
 }
 
 task("runServer", JavaExec::class) {
+    dependsOn(tasks["runRecipeGenerator"])
     val mpDir = File(workingDir, "mp")
     mpDir.mkdir()
     workingDir = mpDir
@@ -180,7 +189,7 @@ task("runServer", JavaExec::class) {
 }
 
 task("runClient", JavaExec::class) {
-    dependsOn(tasks["copyNatives"])
+    dependsOn(tasks["copyNatives"], tasks["runRecipeGenerator"])
     group = "bta"
     mainClass.set("net.minecraft.client.Minecraft")
     classpath = sourceSets["main"].runtimeClasspath
@@ -202,6 +211,33 @@ task("runColorizerGenerator", JavaExec::class) {
     systemProperty("java.library.path", layout.buildDirectory.dir("natives").get().asFile.absolutePath)
 }
 
+val createManifestFileTask = tasks.register("createManifestFileTask") {
+    group = "bta"
+    outputs.dir(temporaryDir)
+
+    doLast {
+        val resource = File(temporaryDir, "manifest.json")
+        resource.writeText(
+            "{\n" +
+                "    \"description\": {\n" +
+                "        \"name\": \"Default\",\n" +
+                "        \"line1\": \"The default look of Minecraft.\",\n" +
+                "        \"line2\": \"\",\n" +
+                "        \"packVersion\": \"$version\",\n" +
+                "        \"format\": $texturePackVersion\n" +
+                "    }\n" +
+                "}")
+    }
+}
+
+sourceSets {
+    main {
+        resources {
+            srcDir(createManifestFileTask.map { it.temporaryDir })
+        }
+    }
+}
+
 java {
     sourceCompatibility = JavaVersion.VERSION_1_8
     targetCompatibility = JavaVersion.VERSION_1_8
diff --git a/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/UndyeDisplayAdapter.java b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/UndyeDisplayAdapter.java
index bc8b8a0dd..8cf1d64a5 100644
--- a/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/UndyeDisplayAdapter.java
+++ b/src/main/java/net/minecraft/client/gui/guidebook/crafting/displays/UndyeDisplayAdapter.java
@@ -4,6 +4,7 @@ import net.minecraft.client.gui.guidebook.GuidebookSlot;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.data.registry.recipe.RecipeSymbol;
 import net.minecraft.core.data.registry.recipe.entry.RecipeEntryUndyeing;
+import net.minecraft.core.item.ItemStack;
 
 import java.util.ArrayList;
 import java.util.List;
@@ -25,7 +26,7 @@ public class UndyeDisplayAdapter implements RecipeDisplayAdapter<RecipeEntryUndy
         }
 
         int centerY = (recipeSlots.get(recipeSlots.size()-1).y + recipeSlots.get(recipeSlots.size()-8).y) / 2;
-        recipeSlots.add(new GuidebookSlot(slotsAmount - 1, 81 + xOffset, centerY, new RecipeSymbol(recipe.output.copy()), false,recipe).setAsOutput());
+        recipeSlots.add(new GuidebookSlot(slotsAmount - 1, 81 + xOffset, centerY, new RecipeSymbol(new ItemStack(recipe.output.getItem(), 8, recipe.output.getMetadata())), false,recipe).setAsOutput());
 
 
         return recipeSlots;
diff --git a/src/main/java/net/minecraft/client/gui/options/OptionsScreen.java b/src/main/java/net/minecraft/client/gui/options/OptionsScreen.java
index 8df1f345e..329332f54 100644
--- a/src/main/java/net/minecraft/client/gui/options/OptionsScreen.java
+++ b/src/main/java/net/minecraft/client/gui/options/OptionsScreen.java
@@ -94,6 +94,7 @@ public class OptionsScreen
 
         if (eventKey == Keyboard.KEY_ESCAPE)
         {
+            mc.texturePackList.refreshIfReady(); // Sets the texturepacks on menu close
             mc.displayScreen(getParentScreen());
         }
         else
diff --git a/src/main/java/net/minecraft/client/render/entity/ArmoredZombieRenderer.java b/src/main/java/net/minecraft/client/render/entity/ArmoredZombieRenderer.java
index eaf652b09..6058284fb 100644
--- a/src/main/java/net/minecraft/client/render/entity/ArmoredZombieRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/ArmoredZombieRenderer.java
@@ -17,7 +17,8 @@ public class ArmoredZombieRenderer extends BipedRenderer<ZombieArmoredMob>
         modelArmor = new ZombieModel(0.5F);
     }
 
-    protected boolean setArmorModel(ZombieArmoredMob zombie, int renderPass, float partialTick)
+    @Override
+    protected boolean prepareArmor(ZombieArmoredMob zombie, int renderPass, float partialTick)
     {
         bindTexture("/assets/minecraft/textures/armor/chain" + "_" + (renderPass != 2 ? 1 : 2) + ".png");
         ZombieModel model = renderPass != 2 ? modelArmorChestplate : modelArmor;
@@ -44,12 +45,6 @@ public class ArmoredZombieRenderer extends BipedRenderer<ZombieArmoredMob>
         return true;
     }
 
-    @Override
-    protected boolean prepareArmor(ZombieArmoredMob zombie, int renderPass, float partialTick)
-    {
-        return setArmorModel(zombie, renderPass, partialTick);
-    }
-
     private void hideArmorPiece(int piece)
     {
         if (piece == 0)
diff --git a/src/main/java/net/minecraft/client/render/entity/MinecartRenderer.java b/src/main/java/net/minecraft/client/render/entity/MinecartRenderer.java
index 46e873873..9f035a6ca 100644
--- a/src/main/java/net/minecraft/client/render/entity/MinecartRenderer.java
+++ b/src/main/java/net/minecraft/client/render/entity/MinecartRenderer.java
@@ -6,6 +6,7 @@ import net.minecraft.client.render.model.BaseModel;
 import net.minecraft.client.render.model.MinecartModel;
 import net.minecraft.client.render.texture.stitcher.TextureRegistry;
 import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.core.block.Block;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.Global;
 import net.minecraft.core.entity.vehicle.MinecartEntity;
@@ -96,7 +97,13 @@ public class MinecartRenderer extends EntityRenderer<MinecartEntity> {
             }
             switch (minecart.type){
                 case MinecartEntity.CHEST_CART:
-                    BlockModelDispatcher.getInstance().getDispatch(Blocks.CHEST_PLANKS_OAK).renderBlockOnInventory(tessellator, 0, brightness, null);
+                    Block block;
+                    if ((minecart.typeMeta & 0b0000_0001) != 0) {
+                        block = Blocks.CHEST_PLANKS_OAK_PAINTED;
+                    } else {
+                        block = Blocks.CHEST_PLANKS_OAK;
+                    }
+                    BlockModelDispatcher.getInstance().getDispatch(block).renderBlockOnInventory(tessellator, minecart.typeMeta, brightness, null);
                     break;
                 case MinecartEntity.FURNACE_CART:
                     if (minecart.fuel > 0) {
diff --git a/src/main/java/net/minecraft/client/render/item/model/StandardItemModel.java b/src/main/java/net/minecraft/client/render/item/model/StandardItemModel.java
index 568cf2247..699ee6cbc 100644
--- a/src/main/java/net/minecraft/client/render/item/model/StandardItemModel.java
+++ b/src/main/java/net/minecraft/client/render/item/model/StandardItemModel.java
@@ -273,7 +273,7 @@ public class StandardItemModel extends ItemModel{
         float vDiff = vMin - vMax;
         final float width = 1.0F;
 
-        final float foon = (0.5f / 512);
+        final float foon = (0.5f / tex.parentAtlas.getHeight());
         final float goon = 0.0625f * (16.0f / tileWidth);
         GL11.glEnable(GL12.GL_RESCALE_NORMAL);
         final float thickness = 0.0625f;
diff --git a/src/main/java/net/minecraft/core/BuildChannel.java b/src/main/java/net/minecraft/core/BuildChannel.java
index 066c404b9..ea4e79ceb 100644
--- a/src/main/java/net/minecraft/core/BuildChannel.java
+++ b/src/main/java/net/minecraft/core/BuildChannel.java
@@ -3,6 +3,7 @@ package net.minecraft.core;
 public enum BuildChannel {
     STABLE,
     PRERELEASE,
+    DEVELOPMENT,
     NIGHTLY;
 
     public boolean isUnstableBuild() {
@@ -12,6 +13,8 @@ public enum BuildChannel {
     public String modifyVersionString(String version) {
         if (this == STABLE || this == PRERELEASE) {
             return version;
+        } else if (this == DEVELOPMENT) {
+            return version + " INDEV";
         } else {
             // Camel case channel name
             String channel = this.name().toLowerCase();
diff --git a/src/main/java/net/minecraft/core/Global.java b/src/main/java/net/minecraft/core/Global.java
index 0acd8a3fc..2dd5c42b9 100644
--- a/src/main/java/net/minecraft/core/Global.java
+++ b/src/main/java/net/minecraft/core/Global.java
@@ -11,7 +11,7 @@ public class Global
 	public static final int CURRENT_CHUNK_VERSION = 2;
 	public static boolean isServer = false;
 	public static final boolean DISABLE_OLD_WORLDS = false;
-	public static final int TEXTURE_PACK_FORMAT = 1;
+	public static final int TEXTURE_PACK_FORMAT = Version.TEXTURE_PACK_VERSION;
 	public static final boolean NET_DEBUG = false;
 	public static MinecraftAccessor accessor;
 
diff --git a/src/main/java/net/minecraft/core/block/entity/JukeboxBlockEntity.java b/src/main/java/net/minecraft/core/block/entity/JukeboxBlockEntity.java
index 819537f2b..311a622a6 100644
--- a/src/main/java/net/minecraft/core/block/entity/JukeboxBlockEntity.java
+++ b/src/main/java/net/minecraft/core/block/entity/JukeboxBlockEntity.java
@@ -8,12 +8,13 @@ import net.minecraft.core.block.Block;
 import net.minecraft.core.entity.Entity;
 import net.minecraft.core.entity.ItemEntity;
 import net.minecraft.core.item.ItemStack;
+import net.minecraft.core.world.LevelListener;
 import net.minecraft.core.world.World;
 import net.minecraft.core.world.save.conversion.ChunkConverter;
 import com.mojang.nbt.CompoundTag;
 
 public class JukeboxBlockEntity extends BlockEntity {
-
+    public int record;
     public JukeboxBlockEntity() {
     }
 
@@ -45,21 +46,19 @@ public class JukeboxBlockEntity extends BlockEntity {
     @Override
     public void dropContents(World world, int x, int y, int z) {
         if (record != 0) {
-            world.playSoundEffect(1005, x, y, z, 0);
-            world.playRecord(null, null, x, y, z);
-            record = 0;
-            setChanged();
-            world.setBlockMetadataWithNotify(x, y, z, 0);
-            int i1 = record;
             float f = 0.7F;
             double d = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
             double d1 = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.2D + 0.6D;
             double d2 = (double) (world.rand.nextFloat() * f) + (double) (1.0F - f) * 0.5D;
-            ItemEntity entityitem = new ItemEntity(world, (double) x + d, (double) y + d1, (double) z + d2, new ItemStack(i1, 1, 0));
-            entityitem.pickupDelay = 10;
-            world.entityJoinedWorld(entityitem);
+            ItemEntity item = new ItemEntity(world, (double) x + d, (double) y + d1, (double) z + d2, new ItemStack(record, 1, 0));
+            item.pickupDelay = 10;
+            world.entityJoinedWorld(item);
+
+            world.playSoundEffect(LevelListener.EVENT_JUKEBOX_TOGGLE, x, y, z, 0);
+            world.playRecord(null, null, x, y, z);
+            record = 0;
+            setChanged();
+            world.setBlockMetadataWithNotify(x, y, z, 0);
         }
     }
-
-    public int record;
 }
diff --git a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryUndyeing.java b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryUndyeing.java
index 31b322fbd..8653a6d12 100644
--- a/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryUndyeing.java
+++ b/src/main/java/net/minecraft/core/data/registry/recipe/entry/RecipeEntryUndyeing.java
@@ -29,20 +29,20 @@ public class RecipeEntryUndyeing extends RecipeEntryCraftingDynamic implements H
 
     @Override
     public boolean matches(CraftingContainer craftingContainer) {
-        if (craftingContainer.getContainerSize() < 9) return false;
+        boolean hasSponge = false;
+        boolean hasItem = false;
         for (int i = 0; i < 9; i++) {
-            if (i == 4) {
-                ItemStack stack = craftingContainer.getItem(i);
-                if (stack == null || stack.getItem() != Blocks.SPONGE_WET.asItem()) {
-                    return false;
-                }
-            } else {
-               if (!inputSymbol.matches(craftingContainer.getItem(i))) {
-                   return false;
-               }
+            ItemStack stack = craftingContainer.getItem(i);
+            if (stack != null && stack.getItem() == Blocks.SPONGE_WET.asItem()) {
+                if (hasSponge) return false;
+                hasSponge = true;
+            } else if (stack != null && !inputSymbol.matches(stack)) {
+                return false;
+            } else if (inputSymbol.matches(stack)) {
+                hasItem = true;
             }
         }
-        return true;
+        return hasSponge && hasItem;
     }
 
     @Override
@@ -127,12 +127,20 @@ public class RecipeEntryUndyeing extends RecipeEntryCraftingDynamic implements H
 
     @Override
     public ItemStack getCraftingResult(CraftingContainer craftingContainer) {
-        return new ItemStack(output);
+        int items = 0;
+        for (int i = 0; i < craftingContainer.getContainerSize(); i++) {
+            ItemStack itemstack1 = craftingContainer.getItem(i);
+            if (itemstack1 == null || itemstack1.getItem() == Blocks.SPONGE_WET.asItem()) {
+                continue;
+            }
+            items++;
+        }
+        return new ItemStack(output.getItem(), items, output.getMetadata());
     }
 
     @Override
     public int getRecipeSize() {
-        return 9;
+        return 2;
     }
 
     @Override
@@ -140,12 +148,10 @@ public class RecipeEntryUndyeing extends RecipeEntryCraftingDynamic implements H
         ItemStack[] returnStack = new ItemStack[9];
         for (int i = 0; i < craftingContainer.getContainerSize(); i++) {
             ItemStack itemstack1 = craftingContainer.getItem(i);
-            if (itemstack1 == null) {
+            if (itemstack1 == null || itemstack1.getItem() == Blocks.SPONGE_WET.asItem()) {
                 continue;
             }
-            if (i != 4) {
-                craftingContainer.removeItem(i, 1);
-            }
+            craftingContainer.removeItem(i, 1);
         }
         return returnStack;
     }
diff --git a/src/main/java/net/minecraft/core/entity/Entity.java b/src/main/java/net/minecraft/core/entity/Entity.java
index 62350c855..f72982319 100644
--- a/src/main/java/net/minecraft/core/entity/Entity.java
+++ b/src/main/java/net/minecraft/core/entity/Entity.java
@@ -114,7 +114,7 @@ public abstract class Entity
     public Entity(World world) {
         this.world = world;
         setPos(0.0D, 0.0D, 0.0D);
-        entityData.define(DATA_SHARED_FLAGS_ID, (byte) 0);
+        entityData.define(DATA_SHARED_FLAGS_ID, (byte) 0, Byte.class);
         defineSynchedData();
     }
 
diff --git a/src/main/java/net/minecraft/core/entity/FishingBobberEntity.java b/src/main/java/net/minecraft/core/entity/FishingBobberEntity.java
index 2238e1ee1..8c02a1a67 100644
--- a/src/main/java/net/minecraft/core/entity/FishingBobberEntity.java
+++ b/src/main/java/net/minecraft/core/entity/FishingBobberEntity.java
@@ -79,7 +79,7 @@ public class FishingBobberEntity extends Entity
     @Override
 	protected void defineSynchedData()
     {
-        entityData.define(ID_BOBBER_BITFIELD, (byte)0);
+        entityData.define(ID_BOBBER_BITFIELD, (byte)0, Byte.class);
     }
 
     public boolean isInGround() {
diff --git a/src/main/java/net/minecraft/core/entity/Mob.java b/src/main/java/net/minecraft/core/entity/Mob.java
index 98992f22b..8d83f3675 100644
--- a/src/main/java/net/minecraft/core/entity/Mob.java
+++ b/src/main/java/net/minecraft/core/entity/Mob.java
@@ -144,8 +144,8 @@ public abstract class Mob extends Entity
         footSize = 0.5F;
 
         int variant = random.nextInt(0xFF);
-        entityData.define(DATA_VARIANT, (byte) variant);
-        entityData.define(DATA_HEALTH, getMaxHealth());
+        entityData.define(DATA_VARIANT, (byte) variant, Byte.class);
+        entityData.define(DATA_HEALTH, getMaxHealth(), Integer.class);
         setSkinVariant(variant);
 
         speed = 0.1f;
diff --git a/src/main/java/net/minecraft/core/entity/PaintingEntity.java b/src/main/java/net/minecraft/core/entity/PaintingEntity.java
index af730d430..25efce7e9 100644
--- a/src/main/java/net/minecraft/core/entity/PaintingEntity.java
+++ b/src/main/java/net/minecraft/core/entity/PaintingEntity.java
@@ -62,8 +62,8 @@ public class PaintingEntity extends Entity
     @Override
     protected void defineSynchedData()
     {
-        entityData.define(DATA_ITEM_ID, (short)0);
-        entityData.define(DATA_ITEM_METADATA_ID, (byte)0);
+        entityData.define(DATA_ITEM_ID, (short)0, Short.class);
+        entityData.define(DATA_ITEM_METADATA_ID, (byte)0, Byte.class);
     }
 
     public void setDirection(int direction)
diff --git a/src/main/java/net/minecraft/core/entity/animal/FireflyClusterMob.java b/src/main/java/net/minecraft/core/entity/animal/FireflyClusterMob.java
index 657bebcb7..7bd199314 100644
--- a/src/main/java/net/minecraft/core/entity/animal/FireflyClusterMob.java
+++ b/src/main/java/net/minecraft/core/entity/animal/FireflyClusterMob.java
@@ -142,9 +142,9 @@ public class FireflyClusterMob extends FlyingMob
     {
         super.defineSynchedData();
 
-		entityData.define(DATA_COLOR_ID, (byte) 0);
-		entityData.define(DATA_CLUSTER_SIZE_ID, (byte) 0);
-		entityData.define(DATA_COUNT_ID, (byte) 0);
+		entityData.define(DATA_COLOR_ID, (byte) 0, Byte.class);
+		entityData.define(DATA_CLUSTER_SIZE_ID, (byte) 0, Byte.class);
+		entityData.define(DATA_COUNT_ID, (byte) 0, Byte.class);
     }
 
 	public void setColor(FireflyColor colour) {
diff --git a/src/main/java/net/minecraft/core/entity/animal/PigMob.java b/src/main/java/net/minecraft/core/entity/animal/PigMob.java
index 7e0e09b61..ddae7d80f 100644
--- a/src/main/java/net/minecraft/core/entity/animal/PigMob.java
+++ b/src/main/java/net/minecraft/core/entity/animal/PigMob.java
@@ -38,7 +38,7 @@ public class PigMob extends Animal
 
     @Override
 	protected void defineSynchedData() {
-        entityData.define(DATA_SADDLE_ID, Byte.valueOf((byte)0));
+        entityData.define(DATA_SADDLE_ID, (byte) 0, Byte.class);
     }
 
     @Override
@@ -118,10 +118,10 @@ public class PigMob extends Animal
     {
         if(flag)
         {
-            entityData.set(DATA_SADDLE_ID, Byte.valueOf((byte)1));
+            entityData.set(DATA_SADDLE_ID, (byte) 1);
         } else
         {
-            entityData.set(DATA_SADDLE_ID, Byte.valueOf((byte)0));
+            entityData.set(DATA_SADDLE_ID, (byte) 0);
         }
     }
 
diff --git a/src/main/java/net/minecraft/core/entity/animal/SheepMob.java b/src/main/java/net/minecraft/core/entity/animal/SheepMob.java
index b8df24232..e47b0eec9 100644
--- a/src/main/java/net/minecraft/core/entity/animal/SheepMob.java
+++ b/src/main/java/net/minecraft/core/entity/animal/SheepMob.java
@@ -34,8 +34,8 @@ public class SheepMob extends Animal
     protected void defineSynchedData()
     {
         super.defineSynchedData();
-        entityData.define(DATA_WOOL_STATE_ID, (byte) 0);
-        entityData.define(DATA_EATING_ID, (byte) 0);
+        entityData.define(DATA_WOOL_STATE_ID, (byte) 0, Byte.class);
+        entityData.define(DATA_EATING_ID, (byte) 0, Byte.class);
     }
 
     @Override
diff --git a/src/main/java/net/minecraft/core/entity/animal/WolfMob.java b/src/main/java/net/minecraft/core/entity/animal/WolfMob.java
index 6165bd753..d59564663 100644
--- a/src/main/java/net/minecraft/core/entity/animal/WolfMob.java
+++ b/src/main/java/net/minecraft/core/entity/animal/WolfMob.java
@@ -30,7 +30,32 @@ import java.util.*;
 
 public class WolfMob extends Animal
 {
+    public static final Map<ArmorMaterial, IArmorItem> ARMOR_MATERIALS = new HashMap<>();
+    static {
+        ARMOR_MATERIALS.put(ArmorMaterial.LEATHER,   (IArmorItem) Items.ARMOR_CHESTPLATE_LEATHER);
+        ARMOR_MATERIALS.put(ArmorMaterial.CHAINMAIL, (IArmorItem) Items.ARMOR_CHESTPLATE_CHAINMAIL);
+        ARMOR_MATERIALS.put(ArmorMaterial.IRON,      (IArmorItem) Items.ARMOR_CHESTPLATE_IRON);
+        ARMOR_MATERIALS.put(ArmorMaterial.GOLD,      (IArmorItem) Items.ARMOR_CHESTPLATE_GOLD);
+        ARMOR_MATERIALS.put(ArmorMaterial.DIAMOND,   (IArmorItem) Items.ARMOR_CHESTPLATE_DIAMOND);
+        ARMOR_MATERIALS.put(ArmorMaterial.STEEL,     (IArmorItem) Items.ARMOR_CHESTPLATE_STEEL);
+    }
+
+    public static final int DATA_HELD_ITEM = 15;
+    public static final int DATA_GENERIC_FLAGS = 16;
+    public static final int MASK_SITTING =  0b0000_0001;
+    public static final int MASK_ANGRY =    0b0000_0010;
+    public static final int MASK_TAMED =    0b0000_0100;
     public static final int DATA_OWNER_UUID = 17;
+    public static final int DATA_ARMOR_MATERIAL = 19;
+
+    private boolean looksWithInterest;
+    private float interestedAngle;
+    private float interestedAngleOld;
+    private boolean isWolfShaking;
+    private boolean field_25052_g;
+    private float timeWolfIsShaking;
+    private float prevTimeWolfIsShaking;
+    private ItemStack armor = null;
 
     public WolfMob(World world)
     {
@@ -52,10 +77,10 @@ public class WolfMob extends Animal
 	protected void defineSynchedData()
     {
         super.defineSynchedData();
-        entityData.define(15, ItemStack.class);
-        entityData.define(16, (byte) 0);
-        entityData.define(DATA_OWNER_UUID, UUID.class);
-        entityData.define(19, "");
+        entityData.define(DATA_HELD_ITEM, null, ItemStack.class);
+        entityData.define(DATA_GENERIC_FLAGS, (byte) 0, Byte.class);
+        entityData.define(DATA_OWNER_UUID, null, UUID.class);
+        entityData.define(DATA_ARMOR_MATERIAL, "", String.class);
     }
     @Override
     public boolean sendDeathMessage(Entity entityKilledBy){
@@ -64,7 +89,7 @@ public class WolfMob extends Animal
 
     public ArmorMaterial getArmorMaterial() {
         ArmorMaterial material = null;
-        String name = entityData.getString(19);
+        String name = entityData.getString(DATA_ARMOR_MATERIAL);
         for (ArmorMaterial mat : ArmorMaterial.getArmorMaterials()) {
             if (mat.identifier.toString().equalsIgnoreCase(name)) {
                 material = mat;
@@ -82,9 +107,9 @@ public class WolfMob extends Animal
             material = ((IArmorItem) stack.getItem()).getArmorMaterial();
         }
         if (material == null) {
-            entityData.set(19, "");
+            entityData.set(DATA_ARMOR_MATERIAL, "");
         } else {
-            entityData.set(19, material.identifier.toString());
+            entityData.set(DATA_ARMOR_MATERIAL, material.identifier.toString());
         }
     }
 
@@ -406,13 +431,13 @@ public class WolfMob extends Animal
 
         }
 
-        field_25054_c = field_25048_b;
+        interestedAngleOld = interestedAngle;
         if(looksWithInterest)
         {
-            field_25048_b = field_25048_b + (1.0F - field_25048_b) * 0.4F;
+            interestedAngle = interestedAngle + (1.0F - interestedAngle) * 0.4F;
         } else
         {
-            field_25048_b = field_25048_b + (0.0F - field_25048_b) * 0.4F;
+            interestedAngle = interestedAngle + (0.0F - interestedAngle) * 0.4F;
         }
         if(looksWithInterest)
         {
@@ -481,7 +506,7 @@ public class WolfMob extends Animal
 
     public float getInterestedAngle(float f)
     {
-        return (field_25054_c + (field_25048_b - field_25054_c) * f) * 0.15F * MathHelper.PI;
+        return (interestedAngleOld + (interestedAngle - interestedAngleOld) * f) * 0.15F * MathHelper.PI;
     }
 
     @Override
@@ -618,9 +643,9 @@ public class WolfMob extends Animal
                 double d = entity.x - x;
                 double d1 = entity.z - z;
                 float f1 = MathHelper.sqrt(d * d + d1 * d1);
-                xd = (d / (double)f1) * 0.5D * 0.80000001192092896D + xd * 0.2D;
-                zd = (d1 / (double)f1) * 0.5D * 0.80000001192092896D + zd * 0.2D;
-                yd = 0.40000000596046448D;
+                xd = (d / (double)f1) * 0.5D * 0.8D + xd * 0.2D;
+                zd = (d1 / (double)f1) * 0.5D * 0.8D + zd * 0.2D;
+                yd = 0.4D;
             }
         } else
         if((double) distance < 1.5D && entity.bb.maxY > bb.minY && entity.bb.minY < bb.maxY)
@@ -802,78 +827,60 @@ public class WolfMob extends Animal
 
     public boolean isWolfSitting()
     {
-        return (entityData.getByte(16) & 1) != 0;
+        return (entityData.getByte(DATA_GENERIC_FLAGS) & 1) != 0;
     }
 
     public void setWolfSitting(boolean flag)
     {
-        byte byte0 = entityData.getByte(16);
+        byte data = entityData.getByte(DATA_GENERIC_FLAGS);
         if(flag)
         {
-            entityData.set(16, (byte) (byte0 | 1));
+            entityData.set(DATA_GENERIC_FLAGS, (byte) (data | MASK_SITTING));
         } else
         {
-            entityData.set(16, (byte) (byte0 & ~1));
+            entityData.set(DATA_GENERIC_FLAGS, (byte) (data & ~MASK_SITTING));
         }
     }
 
     public boolean isWolfAngry()
     {
-        return (entityData.getByte(16) & 2) != 0;
+        return (entityData.getByte(DATA_GENERIC_FLAGS) & MASK_ANGRY) != 0;
     }
 
     public void setWolfAngry(boolean flag)
     {
-        byte byte0 = entityData.getByte(16);
+        byte data = entityData.getByte(DATA_GENERIC_FLAGS);
         if(flag)
         {
-            entityData.set(16, Byte.valueOf((byte)(byte0 | 2)));
+            entityData.set(DATA_GENERIC_FLAGS, (byte) (data | MASK_ANGRY));
         } else
         {
-            entityData.set(16, Byte.valueOf((byte)(byte0 & -3)));
+            entityData.set(DATA_GENERIC_FLAGS, (byte) (data & ~MASK_ANGRY));
         }
     }
 
     public ItemStack getWolfHeldItem(){
-        return entityData.getItemStack(15);
+        return entityData.getItemStack(DATA_HELD_ITEM);
     }
 
     public void setWolfHeldItem(ItemStack itemStack){
-        entityData.set(15, itemStack);
+        entityData.set(DATA_HELD_ITEM, itemStack);
     }
 
     public boolean isWolfTamed()
     {
-        return (entityData.getByte(16) & 4) != 0;
+        return (entityData.getByte(DATA_GENERIC_FLAGS) & MASK_TAMED) != 0;
     }
 
     public void setWolfTamed(boolean flag)
     {
-        byte byte0 = entityData.getByte(16);
+        byte data = entityData.getByte(DATA_GENERIC_FLAGS);
         if(flag)
         {
-            entityData.set(16, (byte) (byte0 | 4));
+            entityData.set(DATA_GENERIC_FLAGS, (byte) (data | MASK_TAMED));
         } else
         {
-            entityData.set(16, (byte) (byte0 & -5));
+            entityData.set(DATA_GENERIC_FLAGS, (byte) (data & ~MASK_TAMED));
         }
     }
-
-    private boolean looksWithInterest;
-    private float field_25048_b;
-    private float field_25054_c;
-    private boolean isWolfShaking;
-    private boolean field_25052_g;
-    private float timeWolfIsShaking;
-    private float prevTimeWolfIsShaking;
-    private ItemStack armor = null;
-    public static final Map<ArmorMaterial, IArmorItem> ARMOR_MATERIALS = new HashMap<>();
-    static {
-        ARMOR_MATERIALS.put(ArmorMaterial.LEATHER,   (IArmorItem) Items.ARMOR_CHESTPLATE_LEATHER);
-        ARMOR_MATERIALS.put(ArmorMaterial.CHAINMAIL, (IArmorItem) Items.ARMOR_CHESTPLATE_CHAINMAIL);
-        ARMOR_MATERIALS.put(ArmorMaterial.IRON,      (IArmorItem) Items.ARMOR_CHESTPLATE_IRON);
-        ARMOR_MATERIALS.put(ArmorMaterial.GOLD,      (IArmorItem) Items.ARMOR_CHESTPLATE_GOLD);
-        ARMOR_MATERIALS.put(ArmorMaterial.DIAMOND,   (IArmorItem) Items.ARMOR_CHESTPLATE_DIAMOND);
-        ARMOR_MATERIALS.put(ArmorMaterial.STEEL,     (IArmorItem) Items.ARMOR_CHESTPLATE_STEEL);
-    }
 }
